import { EitherAnd } from "matrix-events-sdk/lib/types";
import { MatrixEvent } from "../matrix";
import { Focus } from "./focus";
type CallScope = "m.room" | "m.user";
export type SessionMembershipData = {
    application: string;
    call_id: string;
    device_id: string;
    focus_active: Focus;
    foci_preferred: Focus[];
    created_ts?: number;
    scope?: CallScope;
};
export declare const isSessionMembershipData: (data: CallMembershipData) => data is SessionMembershipData;
export type CallMembershipDataLegacy = {
    application: string;
    call_id: string;
    scope: CallScope;
    device_id: string;
    membershipID: string;
    created_ts?: number;
    foci_active?: Focus[];
} & EitherAnd<{
    expires: number;
}, {
    expires_ts: number;
}>;
export declare const isLegacyCallMembershipData: (data: CallMembershipData) => data is CallMembershipDataLegacy;
export type CallMembershipData = CallMembershipDataLegacy | SessionMembershipData;
export declare class CallMembership {
    private parentEvent;
    static equal(a: CallMembership, b: CallMembership): boolean;
    private membershipData;
    constructor(parentEvent: MatrixEvent, data: any);
    get sender(): string | undefined;
    get callId(): string;
    get deviceId(): string;
    get application(): string | undefined;
    get scope(): CallScope | undefined;
    get membershipID(): string;
    createdTs(): number;
    getAbsoluteExpiry(): number | undefined;
    getLocalExpiry(): number | undefined;
    getMsUntilExpiry(): number | undefined;
    isExpired(): boolean;
    getPreferredFoci(): Focus[];
    getFocusSelection(): string | undefined;
}
export {};
//# sourceMappingURL=CallMembership.d.ts.map